## lsp-mode 6.0

=== Makefile ===
SHELL := /bin/bash

all:
	cask build

test: all
	cask exec ert-runner

.PHONY: all test

## lsp-mode 5.0

=== debian/changelog ===
lsp-mode (5.0-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: 905691)

 -- Thomas Koch <thomas@koch.ro>  Wed, 31 Oct 2018 08:03:03 +0100

=== debian/control ===
Source: lsp-mode
Section: lisp
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders: Thomas Koch <thomas@koch.ro>
Build-Depends: debhelper (>= 11),
 dh-elpa,
 elpa-f
Standards-Version: 4.2.1
Homepage: https://github.com/emacs-lsp/lsp-mode
Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode
Vcs-Git: https://salsa.debian.org/emacsen-team/lsp-mode.git
Testsuite: autopkgtest-pkg-elpa

Package: elpa-lsp-mode
Architecture: all
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs (>= 46.0)
Enhances: emacs,
 emacs25
Description: Emacs client/library for the Language Server Protocol
 A Emacs Lisp library for implementing clients for servers using Microsoft's
 Language Server Protocol (v3.0)[1].
 .
 The library is designed to integrate with existing Emacs IDE frameworks
 (completion-at-point, xref (beginning with Emacs 25.1), flycheck, etc).
 .
 [1]: https://github.com/Microsoft/language-server-protocol

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	/bin/true
	# https://github.com/emacs-lsp/lsp-mode/pull/468
	chmod a-x lsp-common.el

## lsp-mode 6.0

=== debian/changelog ===
lsp-mode (6.0-1) unstable; urgency=medium

  * new upstream release
  * update Standards-Version -> 4.3.0, no changes

 -- Thomas Koch <thomas@koch.ro>  Mon, 21 Jan 2019 20:56:43 +0000

lsp-mode (5.0-1) unstable; urgency=medium

  * Initial release. (Closes: 905691)

 -- Thomas Koch <thomas@koch.ro>  Wed, 31 Oct 2018 08:03:03 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,10 @@
 Uploaders: Thomas Koch <thomas@koch.ro>
 Build-Depends: debhelper (>= 11),
  dh-elpa,
- elpa-f
-Standards-Version: 4.2.1
+ elpa-f,
+ elpa-ht,
+ elpa-spinner,
+Standards-Version: 4.3.0
 Homepage: https://github.com/emacs-lsp/lsp-mode
 Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode
 Vcs-Git: https://salsa.debian.org/emacsen-team/lsp-mode.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	/bin/true

## lsp-mode 6.2.1

=== Makefile ===
SHELL := /bin/bash

all:
	cask build

test: all
	cask exec ert-runner -t '!no-win'

docs:
	make -C doc/ all

.PHONY: all test

=== doc/Makefile ===
all: doc-html doc-pdf

output-dir:
	mkdir -p output

doc-html: output-dir
	asciidoctor --safe -b html5 -B ./src/ -D output -o lsp-mode.html ./src/lsp-mode.adoc
	cp ./src/output/* ./output/

doc-pdf: output-dir
	asciidoctor-pdf  --safe -B ./src/ -D output -o lsp-mode.pdf ./src/lsp-mode.adoc
	cp ./src/output/* ./output/

clean:
	rm -rf ./src/output output

.DEFAULT_GOAL: all

=== debian/changelog ===
lsp-mode (6.2.1-3) unstable; urgency=medium

  * update Standards-Version 4.4.1->4.5.0, no changes
  * fix target release in d/changelog s/UNRELEASED/unstable/

 -- Thomas Koch <thomas@koch.ro>  Wed, 05 Feb 2020 12:42:12 +0000

lsp-mode (6.2.1-2) unstable; urgency=medium

  * patch dependeny version of dash-functional

 -- Thomas Koch <thomas@koch.ro>  Sat, 01 Feb 2020 13:29:48 +0000

lsp-mode (6.2.1-1) unstable; urgency=medium

  * update Standards-Version 4.3.0->4.4.1, no changes
  * update debhelper 11->12, use debhelper-compat
  * new upstream version (Closes: 927749)

 -- Thomas Koch <thomas@koch.ro>  Thu, 30 Jan 2020 17:12:59 +0000

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,16 @@
 Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders: Thomas Koch <thomas@koch.ro>
-Build-Depends: debhelper (>= 11),
+Build-Depends:
+ debhelper-compat (= 12),
  dh-elpa,
+ elpa-dash-functional,
  elpa-f,
  elpa-ht,
+ elpa-lv,
+ elpa-markdown-mode,
  elpa-spinner,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/emacs-lsp/lsp-mode
 Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode
 Vcs-Git: https://salsa.debian.org/emacsen-team/lsp-mode.git

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/lsp-mode.git-$1.tar.gz/" \
    https://github.com/emacs-lsp/lsp-mode/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## lsp-mode 7.0.1

=== Makefile ===
SHELL := /usr/bin/env bash

EMACS ?= emacs
CASK ?= cask

INIT="(progn \
  (require 'package) \
  (push '(\"melpa\" . \"https://melpa.org/packages/\") package-archives) \
  (package-initialize) \
  (package-refresh-contents))"

LINT="(progn \
		(unless (package-installed-p 'package-lint) \
		  (package-install 'package-lint)) \
		(require 'package-lint) \
		(package-lint-batch-and-exit))"

all:
	$(CASK) build

build:
	$(CASK) install

# TODO: add 'checkdoc' and 'lint' here when they pass
ci: clean build compile testprereq test

compile:
	@echo "Compiling..."
	@$(CASK) $(EMACS) -Q --batch \
		-L . \
		--eval '(setq byte-compile-error-on-warn t)' \
		-f batch-byte-compile \
		*.el

checkdoc:
	$(eval LOG := $(shell mktemp -d)/checklog.log)
	@touch $(LOG)

	@echo "checking doc..."

	@for f in *.el ; do \
		$(CASK) $(EMACS) -Q --batch \
			-L . \
			--eval "(checkdoc-file \"$$f\")" \
			*.el 2>&1 | tee -a $(LOG); \
	done

	@if [ -s $(LOG) ]; then \
		echo ''; \
		exit 1; \
	else \
		echo 'checkdoc ok!'; \
	fi

lint:
	@echo "package linting..."
	@$(CASK) $(EMACS) -Q --batch \
		-L . \
		--eval $(INIT) \
		--eval $(LINT) \
		*.el

testprereq:
	sudo pip install python-language-server

test:
	$(CASK) exec ert-runner -t '!no-win' -t '!org'

docs:
	make -C docs/ generate

local-webpage: docs
	cp -rf README.md examples docs
	docker run --rm --volume "`pwd`:/data" --user `id -u`:`id -g` pandoc/core:2.9 -s CHANGELOG.org -t gfm -o docs/page/CHANGELOG.md
	docker run --rm -it -p 8000:8000 -v ${PWD}:/docs squidfunk/mkdocs-material

clean:
	rm -rf .cask *.elc

.PHONY: all build ci compile checkdoc lint testprereq test docs local-webpage clean

=== docs/Makefile ===
SHELL := /usr/bin/env bash

deps:
	cask

generate: deps
	@echo "Generating..."

	@cask emacs -Q --batch \
		-L ../ \
		-l lsp-doc.el \
		-f lsp-doc-generate

.PHONY: deps generate

=== debian/changelog ===
lsp-mode (7.0.1-3) unstable; urgency=medium

  * Team upload.
  * Drop 01_dash-functional_version.patch.
  * Add don-t-depend-on-dash-functional.patch & drop elpa-dash-functional b-d.
    See <https://github.com/magnars/dash.el/wiki/Obsoletion-of-dash-functional.el>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 18 Oct 2021 12:30:09 -0700

lsp-mode (7.0.1-2) unstable; urgency=medium

  * Fix autopkgtest

 -- Thomas Koch <thomas@koch.ro>  Tue, 13 Oct 2020 21:21:04 +0200

lsp-mode (7.0.1-1) unstable; urgency=medium

  * new upstream release

 -- Thomas Koch <thomas@koch.ro>  Sat, 10 Oct 2020 20:38:01 +0200

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
 Build-Depends:
  debhelper-compat (= 12),
  dh-elpa,
- elpa-dash-functional,
+ elpa-deferred,
  elpa-f,
  elpa-ht,
  elpa-lv,
  elpa-markdown-mode,
  elpa-spinner,
+ elpa-undercover
 Standards-Version: 4.5.0
 Homepage: https://github.com/emacs-lsp/lsp-mode
 Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode

## lsp-mode 8.0.0

=== Makefile ===
SHELL := /usr/bin/env bash

EMACS ?= emacs
CASK ?= cask

INIT="(progn \
  (require 'package) \
  (push '(\"melpa\" . \"https://melpa.org/packages/\") package-archives) \
  (package-initialize) \
  (package-refresh-contents))"

LINT="(progn \
		(unless (package-installed-p 'package-lint) \
		  (package-install 'package-lint)) \
		(require 'package-lint) \
		(package-lint-batch-and-exit))"

LSP-FILES := lsp-protocol.el lsp-mode.el lsp.el lsp-completion.el \
		lsp-diagnostics.el lsp-lens.el lsp-modeline.el \
		$(wildcard clients/*.el)

WIN-BOOTSTRAP=test/windows-bootstrap.el
TEST-PKGS=test/test-packages.el

TEST-FILES := test/test-helper.el $(shell ls test/lsp-*.el)
LOAD-FILE = -l $(test-file)
LOAD-TEST-FILES := $(foreach test-file, $(TEST-FILES), $(LOAD-FILE))

all:
	$(CASK) build

unix-build:
	$(CASK) install

# TODO: add 'checkdoc' and 'lint' here when they pass
unix-ci: clean unix-build unix-compile prepare_cpp_project unix-test test-downstream-pkgs

windows-ci: CASK=
windows-ci: clean windows-compile windows-test test-downstream-pkgs

unix-compile:
	@echo "Compiling..."
	@$(CASK) $(EMACS) -Q --batch \
		-L . -L clients \
		--eval '(setq byte-compile-error-on-warn t)' \
		-f batch-byte-compile $(LSP-FILES)

prepare_cpp_project:
	@echo "Setting up Sample C++ project with CMake and clangd"
	cd test/fixtures/SampleCppProject/ && mkdir -p build && cd build/ && cmake ..

windows-compile:
	@echo "Compiling..."
	@$(CASK) $(EMACS) -Q --batch \
		--eval '(setq emacs-lsp-ci t)' \
		-l $(WIN-BOOTSTRAP) \
		-L . -L clients \
		--eval '(setq byte-compile-error-on-warn t)' \
		-f batch-byte-compile $(LSP-FILES)

test-downstream-pkgs:
	@echo "Test downstream packages..."
	@$(CASK) $(EMACS) -Q --batch \
		--eval '(setq emacs-lsp-ci t)' \
		-l $(WIN-BOOTSTRAP) \
		-l $(TEST-PKGS)

checkdoc:
	$(eval LOG := $(shell mktemp -d)/checklog.log)
	@touch $(LOG)

	@echo "checking doc..."

	@for f in $(LSP-FILES); do \
		$(CASK) $(EMACS) -Q --batch \
			--eval "(checkdoc-file \"$$f\")" \
			2>&1 | tee -a $(LOG); \
	done

	@if [ -s $(LOG) ]; then \
		echo ''; \
		exit 1; \
	else \
		echo 'checkdoc ok!'; \
	fi

lint:
	@echo "package linting..."
	@$(CASK) $(EMACS) -Q --batch \
		-L . -L clients \
		--eval $(INIT) \
		--eval $(LINT) \
		$(LSP-FILES)

unix-test:
	@echo "Testing..."
	$(CASK) exec ert-runner -L . -L clients	$(LOAD-TEST-FILES) -t '!no-win' -t '!org'

windows-test:
	@echo "Testing..."
	@$(EMACS) -Q --batch \
		--eval '(setq emacs-lsp-ci t)' \
		-l $(WIN-BOOTSTRAP) \
		-L . -L clients \
		$(LOAD-TEST-FILES) \
		--eval "(ert-run-tests-batch-and-exit \
		'(and (not (tag no-win)) (not (tag org))))"

docs:
	make -C docs/ generate

local-webpage: docs
	cp -rf README.md examples docs
	docker run --rm --volume "`pwd`:/data" --user `id -u`:`id -g` pandoc/core:2.9 -s CHANGELOG.org -t gfm -o docs/page/CHANGELOG.md
	docker login docker.pkg.github.com
	docker run --rm -it -p 8000:8000 -v ${PWD}:/docs docker.pkg.github.com/emacs-lsp/docs-image/docs-image

clean:
	rm -rf .cask *.elc clients/*.elc
	rm -rf test/fixtures/SampleCppProject/build test/fixtures/SampleCppProject/.cache


.PHONY: all unix-build ci unix-compile windows-compile checkdoc lint unix-test windows-test docs local-webpage clean

=== test/fixtures/SampleCppProject/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

project(test)

add_subdirectory(src)

=== debian/changelog ===
lsp-mode (8.0.0-6) unstable; urgency=medium

  [ Arto Jantunen ]
  * Team upload
  * Remove myself from Uploaders

  [ Xiyue Deng ]
  * Use unpatched source
  * Don't require pristine-tar
  * Add patch to fix test failures (Closes: #1052939)
  * Make patches DEP-3 compatible.
  * Update Standards-Version to 4.6.2.  No change needed.
  * Add myself as uploader (Closes: #1042568)
  * Add signing key verification to d/watch
  * Add d/upstream/metadata
  * Add Upstream-Contact and update year in d/copyright
  * Add patch to fix non-UTF-8 encoding
  * Drop unused lintian overrides
  * Ensure dependent test is loaded first to avoid flakiness
  * Add upstream bug in comments

 -- Arto Jantunen <viiru@debian.org>  Sun, 26 Nov 2023 14:40:48 +0200

lsp-mode (8.0.0-5) unstable; urgency=medium

  * Remove Thomas Koch from uploaders (Closes: #1019022)
  * Add myself to uploaders
  * Cherry-pick parts of upstream commit 7f331321c565 (Closes: #1022304)
  * Bump Standards-Version, no changes
  * Commit Debian 3.0 (quilt) metadata

 -- Arto Jantunen <viiru@debian.org>  Fri, 28 Oct 2022 13:40:46 +0300

lsp-mode (8.0.0-4) unstable; urgency=medium

  * Team upload.
  * Enable tests requiring python-language-server.
  * Add super-simple autopkgtests control file to run the upstream testsuite.

 -- Arto Jantunen <viiru@debian.org>  Sun, 10 Apr 2022 11:58:44 +0300

lsp-mode (8.0.0-3) unstable; urgency=medium

  * add missing clients/ directory, fix tests
    (Closes: #1003103) Thanks to Arto Jantunen (viiru@)

 -- Thomas Koch <thomas@koch.ro>  Tue, 04 Jan 2022 13:26:45 +0200

lsp-mode (8.0.0-2) unstable; urgency=medium

  * disable tests until I get them to run

 -- Thomas Koch <thomas@koch.ro>  Mon, 03 Jan 2022 13:27:19 +0200

lsp-mode (8.0.0-1) unstable; urgency=medium

  * new upstream version (Closes: #998214)
  * update Standards-Version 4.5.0->4.6.0
  * update debhelper-compat 12->13
  * fix Lintian: add Rules-Requires-Root: no

 -- Thomas Koch <thomas@koch.ro>  Sun, 02 Jan 2022 21:11:20 +0200

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,26 @@
 Section: lisp
 Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
-Uploaders: Thomas Koch <thomas@koch.ro>
+Uploaders: Xiyue Deng <manphiz@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ clangd,
+ debhelper-compat (= 13),
  dh-elpa,
  elpa-deferred,
+ elpa-el-mock,
  elpa-f,
  elpa-ht,
  elpa-lv,
  elpa-markdown-mode,
  elpa-spinner,
- elpa-undercover
-Standards-Version: 4.5.0
+ elpa-undercover,
+ python3-pylsp,
+Standards-Version: 4.6.2
 Homepage: https://github.com/emacs-lsp/lsp-mode
 Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode
 Vcs-Git: https://salsa.debian.org/emacsen-team/lsp-mode.git
 Testsuite: autopkgtest-pkg-elpa
+Rules-Requires-Root: no
 
 Package: elpa-lsp-mode
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	/bin/true

# In the ert tests, `lsp-clangd-test' requires `lsp-integration-test'.  If
# `lsp-clangd-test.el' is loaded before `lsp-integration-test.el' in Emacs 29,
# it causes test symbols to be loaded twice which triggers the `test redefined'
# error.  Here we ensure `lsp-clangd-test' is loaded after
# `lsp-integration-test' to avoid flakiness.
# See also: https://debbugs.gnu.org/66782
override_dh_elpa_test:
	emacs -batch -Q -l package \
	--eval "(add-to-list 'package-directory-list \"/usr/share/emacs/site-lisp/elpa\")" \
	--eval "(add-to-list 'package-directory-list \"/usr/share/emacs/site-lisp/elpa-src\")" \
	-f package-initialize -L clients/ -L . -L test \
	-l test/lsp-integration-test.el \
	-l test/lsp-common-test.el \
	-l test/lsp-protocol-test.el \
	-l test/lsp-mode-test.el \
	-l test/lsp-methods-test.el \
	-l test/lsp-javascript-test.el \
	-l test/lsp-io-test.el \
	-l test/lsp-file-watch-test.el \
	-l test/lsp-completion-test.el \
	-l test/lsp-clangd-test.el \
	-l debian/ert-helper.el

=== debian/tests/control ===
Test-Command: dh_elpa_test --autopkgtest
Depends: @, clangd, dh-elpa, elpa-deferred, elpa-el-mock, python3-pylsp

## lsp-mode 9.0.0

=== Makefile ===
SHELL := /usr/bin/env bash

EMACS ?= emacs
EASK ?= eask

TEST-FILES := test/test-helper.el $(shell ls test/lsp-*.el)
LOAD-FILE = -l $(test-file)
LOAD-TEST-FILES := $(foreach test-file, $(TEST-FILES), $(LOAD-FILE))

# TODO: add 'checkdoc' and 'lint' here when they pass
unix-ci: clean build compile prepare_cpp_project unix-test
# TODO: add 'windows-test' back
windows-ci: clean build compile prepare_cpp_project

build:
	$(EASK) package
	$(EASK) install

compile:
	@echo "Compiling..."
	$(EASK) compile

prepare_cpp_project:
	@echo "Setting up Sample C++ project with CMake and clangd"
	cd test/fixtures/SampleCppProject/ && mkdir -p build && cd build/ && cmake ..

test-downstream-pkgs:
	@echo "Test downstream packages..."
	./test/downstream/run.sh

checkdoc:
	@echo "Run checkdoc..."
	$(EASK) lint checkdoc

lint:
	@echo "Package linting..."
	$(EASK) lint package

unix-test:
	@echo "Testing..."
	$(EASK) install-deps --dev
	$(EASK) exec ert-runner -L . -L clients -t '!no-win' -t '!org'

windows-test:
	@echo "Testing..."
	$(EASK) install-deps --dev
	$(EASK) exec ert-runner

docs:
	make -C docs/ generate

local-webpage: docs
	cp -rf README.md examples docs
	docker run --rm --volume "`pwd`:/data" --user `id -u`:`id -g` pandoc/core:2.9 -s CHANGELOG.org -t gfm -o docs/page/CHANGELOG.md
	docker login docker.pkg.github.com
	docker run --rm -it -p 8000:8000 -v ${PWD}:/docs docker.pkg.github.com/emacs-lsp/docs-image/docs-image

clean:
	$(EASK) clean all
	rm -rf test/fixtures/SampleCppProject/build test/fixtures/SampleCppProject/.cache


.PHONY: build ci compile checkdoc lint test docs local-webpage clean

=== docs/Makefile ===
SHELL := /usr/bin/env bash

deps:
	cask install

generate: deps
	@echo "Generating docs..."

	@cask emacs -Q --batch \
		-L ../ \
		-L ../clients \
		-l lsp-doc.el \
		-f lsp-doc-generate

.PHONY: deps generate

=== test/fixtures/SampleCppProject/src/CMakeLists.txt ===
add_executable(test_binary main.cpp individual_file.cpp)

=== debian/changelog ===
lsp-mode (9.0.0-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 22:33:06 +0900

lsp-mode (9.0.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1052939)
  * Drop obsolete version from Recommends and emacs25 from Enhances
  * Add newly required elpa-elenv to Build-Depends in d/control
  * Override dh auto clean to avoid using eask
  * Drop workaround of dh_elpa_test in favor of upstream fix
  * Skip test that fails in autopkgtest trying to overwrite without ACL
  * Use @builddeps@ in autopkgtest Depends to ensure B-D are available

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 07 Apr 2024 03:02:21 -0700

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  dh-elpa,
  elpa-deferred,
  elpa-el-mock,
+ elpa-elenv,
  elpa-f,
  elpa-ht,
  elpa-lv,
@@ -16,7 +17,7 @@
  elpa-spinner,
  elpa-undercover,
  python3-pylsp,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/emacs-lsp/lsp-mode
 Vcs-Browser: https://salsa.debian.org/emacsen-team/lsp-mode
 Vcs-Git: https://salsa.debian.org/emacsen-team/lsp-mode.git
@@ -26,9 +27,8 @@
 Package: elpa-lsp-mode
 Architecture: all
 Depends: ${elpa:Depends}, ${misc:Depends}
-Recommends: emacs (>= 46.0)
-Enhances: emacs,
- emacs25
+Recommends: emacs
+Enhances: emacs
 Description: Emacs client/library for the Language Server Protocol
  A Emacs Lisp library for implementing clients for servers using Microsoft's
  Language Server Protocol (v3.0)[1].

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	/bin/true

override_dh_auto_clean:
	find . -name "*.elc" -exec rm "{}" \;

=== debian/tests/control ===
Test-Command: dh_elpa_test --autopkgtest
Depends: @, @builddeps@

=== debian/watch ===
version=4
opts="mode=git, pgpsigurlmangle=s/$/.asc/" \
    https://github.com/emacs-lsp/lsp-mode \
    refs/tags/@ANY_VERSION@ debian uupdate
